import type { QueryCustomType } from '../builder';
import { Expression } from './base';
import { Renderable } from './syntax';
export declare type SelectExpressionBuilder<T> = {
    t: Readonly<Required<T>>;
    e: () => SelectExpression<T>;
};
export declare class SelectExpression<T> extends Expression<T> {
    constructor({ children, }?: {
        children?: Renderable[];
    });
    static select<T extends object>(opts: (builder: SelectExpressionBuilder<T>, current?: SelectExpression<T>) => SelectExpression<T>, current?: SelectExpression<T>): SelectExpression<T>;
    render({ aliases, escape, prefix, }?: {
        aliases?: QueryCustomType[] | undefined;
        escape?: boolean | undefined;
        prefix?: string | undefined;
    }): string;
    clone(): SelectExpression<unknown>;
    private _add;
    field(field: any): SelectExpression<T>;
}
