import { HttpContext, HttpHeaders, HttpParams } from '@angular/common/http';
import { FetchPolicy } from '../../types';
import { ODataQueryArguments } from '../query';
export declare type ODataOptions = {
    etag?: string;
    context?: HttpContext;
    headers?: HttpHeaders | {
        [header: string]: string | string[];
    };
    params?: HttpParams | {
        [param: string]: string | number | boolean | ReadonlyArray<string | number | boolean>;
    };
    reportProgress?: boolean;
    withCredentials?: boolean;
    fetchPolicy?: FetchPolicy;
};
export declare type ODataEntityOptions = ODataOptions & {
    responseType?: 'entity';
};
export declare type ODataEntitiesOptions = ODataOptions & {
    responseType?: 'entities';
    withCount?: boolean;
};
export declare type ODataPropertyOptions = ODataOptions & {
    responseType?: 'property';
};
export declare type ODataNoneOptions = ODataOptions & {
    responseType?: 'none';
};
export declare type ODataQueryArgumentsOptions<T> = ODataOptions & ODataQueryArguments<T>;
export declare type ODataActionOptions<T> = ODataQueryArgumentsOptions<T>;
export declare type ODataFunctionOptions<T> = ODataQueryArgumentsOptions<T> & {
    alias?: boolean;
};
